#version 120

/* DRAWBUFFERS:024 */


const int RGB16 = 2;
const int RGBA16 = 3;
const int gnormalFormat = RGB16;
const int compositeFormat = RGBA16;
const int GL_EXP = 2048;
const int GL_LINEAR = 9729;
const int MAX_OCCLUSION_POINTS = 20;


varying vec2 texcoord;
varying vec2 lmcoord;
varying vec3 normal;
varying vec4 color;
varying float translucent;

varying vec3 tangent;
varying vec3 binormal;
varying float distance;
varying vec3 viewVectorRaw;

uniform sampler2D texture;
uniform sampler2D normals;
uniform sampler2D specular;
uniform vec3 sunPosition;
uniform vec3 moonPosition;
uniform int fogMode;
uniform int worldTime;
uniform float wetness;


void main() {	
	
	vec2 adjustedTexCoord = texcoord.st;
	vec3 lightVector;
	vec3 indlmap = mix(pow(min(lmcoord.t+0.1,1.0),2.0),1.0,lmcoord.s)*texture2D(texture,adjustedTexCoord).rgb*color.rgb;
	vec4 frag2 = vec4(vec3(normal) * 0.5 + 0.5, 1.0f);
	
	float dirtest = 0.4;
	float pomsample = 0.0;
	float texinterval = 0.0625;
	
	if (worldTime < 12700 || worldTime > 23250) {
		lightVector = normalize(sunPosition);
	} else {
		lightVector = normalize(moonPosition);
	}
	
	dirtest = mix(1.0-0.8*step(dot(frag2.xyz*2.0-1.0,lightVector),-0.02),0.4,float(translucent > 0.01));

	gl_FragData[0] = vec4(indlmap,texture2D(texture,adjustedTexCoord).a*color.a);	
	

	gl_FragData[1] = frag2;
	vec3 specularity = texture2D(specular,texcoord.xy).rgb;
	float totalspec = (specularity.r + specularity.g * clamp(wetness, 0.0f, 1.0)/1.0 + specularity.b) * 0.333 * mix(min(lmcoord.t+0.1,1.0),1.0,lmcoord.s);
	

	gl_FragData[2] = vec4(totalspec, dirtest, lmcoord.s, 1.0);
	
}